Use hyphenated "remote-tracking branch" (docs and comments)
[git.git] / git-submodule.sh
blobf2e5bea715c3b184b98958c763f5ba9917a996ad
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17 OPTIONS_SPEC=
18 SUBDIRECTORY_OK=Yes
19 . git-sh-setup
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
30 command=
31 branch=
32 force=
33 reference=
34 cached=
35 recursive=
36 init=
37 files=
38 remote=
39 nofetch=
40 update=
41 prefix=
42 custom_name=
43 depth=
44 progress=
46 die_if_unmatched ()
48 if test "$1" = "#unmatched"
49 then
50 exit ${2:-1}
55 # Print a submodule configuration setting
57 # $1 = submodule name
58 # $2 = option name
59 # $3 = default value
61 # Checks in the usual git-config places first (for overrides),
62 # otherwise it falls back on .gitmodules. This allows you to
63 # distribute project-wide defaults in .gitmodules, while still
64 # customizing individual repositories if necessary. If the option is
65 # not in .gitmodules either, print a default value.
67 get_submodule_config () {
68 name="$1"
69 option="$2"
70 default="$3"
71 value=$(git config submodule."$name"."$option")
72 if test -z "$value"
73 then
74 value=$(git config -f .gitmodules submodule."$name"."$option")
76 printf '%s' "${value:-$default}"
79 isnumber()
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
84 # Sanitize the local git environment for use within a submodule. We
85 # can't simply use clear_local_git_env since we want to preserve some
86 # of the settings from GIT_CONFIG_PARAMETERS.
87 sanitize_submodule_env()
89 save_config=$GIT_CONFIG_PARAMETERS
90 clear_local_git_env
91 GIT_CONFIG_PARAMETERS=$save_config
92 export GIT_CONFIG_PARAMETERS
96 # Add a new submodule to the working tree, .gitmodules and the index
98 # $@ = repo path
100 # optional branch is stored in global branch variable
102 cmd_add()
104 # parse $args after "submodule ... add".
105 reference_path=
106 while test $# -ne 0
108 case "$1" in
109 -b | --branch)
110 case "$2" in '') usage ;; esac
111 branch=$2
112 shift
114 -f | --force)
115 force=$1
117 -q|--quiet)
118 GIT_QUIET=1
120 --reference)
121 case "$2" in '') usage ;; esac
122 reference_path=$2
123 shift
125 --reference=*)
126 reference_path="${1#--reference=}"
128 --name)
129 case "$2" in '') usage ;; esac
130 custom_name=$2
131 shift
133 --depth)
134 case "$2" in '') usage ;; esac
135 depth="--depth=$2"
136 shift
138 --depth=*)
139 depth=$1
142 shift
143 break
146 usage
149 break
151 esac
152 shift
153 done
155 if test -n "$reference_path"
156 then
157 is_absolute_path "$reference_path" ||
158 reference_path="$wt_prefix$reference_path"
160 reference="--reference=$reference_path"
163 repo=$1
164 sm_path=$2
166 if test -z "$sm_path"; then
167 sm_path=$(printf '%s\n' "$repo" |
168 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
171 if test -z "$repo" || test -z "$sm_path"; then
172 usage
175 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
177 # assure repo is absolute or relative to parent
178 case "$repo" in
179 ./*|../*)
180 test -z "$wt_prefix" ||
181 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
183 # dereference source url relative to parent's url
184 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
186 *:*|/*)
187 # absolute url
188 realrepo=$repo
191 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
193 esac
195 # normalize path:
196 # multiple //; leading ./; /./; /../; trailing /
197 sm_path=$(printf '%s/\n' "$sm_path" |
198 sed -e '
199 s|//*|/|g
200 s|^\(\./\)*||
201 s|/\(\./\)*|/|g
202 :start
203 s|\([^/]*\)/\.\./||
204 tstart
205 s|/*$||
207 if test -z "$force"
208 then
209 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210 die "$(eval_gettext "'\$sm_path' already exists in the index")"
211 else
212 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
213 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
216 if test -z "$force" &&
217 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
218 then
219 eval_gettextln "The following path is ignored by one of your .gitignore files:
220 \$sm_path
221 Use -f if you really want to add it." >&2
222 exit 1
225 if test -n "$custom_name"
226 then
227 sm_name="$custom_name"
228 else
229 sm_name="$sm_path"
232 if ! git submodule--helper check-name "$sm_name"
233 then
234 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
237 # perhaps the path exists and is already a git repo, else clone it
238 if test -e "$sm_path"
239 then
240 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
241 then
242 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
243 else
244 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
247 else
248 if test -d ".git/modules/$sm_name"
249 then
250 if test -z "$force"
251 then
252 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
253 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
254 die "$(eval_gettextln "\
255 If you want to reuse this local git directory instead of cloning again from
256 \$realrepo
257 use the '--force' option. If the local git directory is not the correct repo
258 or you are unsure what this means choose another name with the '--name' option.")"
259 else
260 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
263 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
265 sanitize_submodule_env
266 cd "$sm_path" &&
267 # ash fails to wordsplit ${branch:+-b "$branch"...}
268 case "$branch" in
269 '') git checkout -f -q ;;
270 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
271 esac
272 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
274 git config submodule."$sm_name".url "$realrepo"
276 git add --no-warn-embedded-repo $force "$sm_path" ||
277 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
279 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
280 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
281 if test -n "$branch"
282 then
283 git config -f .gitmodules submodule."$sm_name".branch "$branch"
284 fi &&
285 git add --force .gitmodules ||
286 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
288 # NEEDSWORK: In a multi-working-tree world, this needs to be
289 # set in the per-worktree config.
290 if git config --get submodule.active >/dev/null
291 then
292 # If the submodule being adding isn't already covered by the
293 # current configured pathspec, set the submodule's active flag
294 if ! git submodule--helper is-active "$sm_path"
295 then
296 git config submodule."$sm_name".active "true"
298 else
299 git config submodule."$sm_name".active "true"
304 # Execute an arbitrary command sequence in each checked out
305 # submodule
307 # $@ = command to execute
309 cmd_foreach()
311 # parse $args after "submodule ... foreach".
312 while test $# -ne 0
314 case "$1" in
315 -q|--quiet)
316 GIT_QUIET=1
318 --recursive)
319 recursive=1
322 usage
325 break
327 esac
328 shift
329 done
331 toplevel=$(pwd)
333 # dup stdin so that it can be restored when running the external
334 # command in the subshell (and a recursive call to this function)
335 exec 3<&0
338 git submodule--helper list --prefix "$wt_prefix" ||
339 echo "#unmatched" $?
341 while read -r mode sha1 stage sm_path
343 die_if_unmatched "$mode" "$sha1"
344 if test -e "$sm_path"/.git
345 then
346 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
347 say "$(eval_gettext "Entering '\$displaypath'")"
348 name=$(git submodule--helper name "$sm_path")
350 prefix="$prefix$sm_path/"
351 sanitize_submodule_env
352 cd "$sm_path" &&
353 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
354 # we make $path available to scripts ...
355 path=$sm_path &&
356 if test $# -eq 1
357 then
358 eval "$1"
359 else
360 "$@"
361 fi &&
362 if test -n "$recursive"
363 then
364 cmd_foreach "--recursive" "$@"
366 ) <&3 3<&- ||
367 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
369 done
373 # Register submodules in .git/config
375 # $@ = requested paths (default to all)
377 cmd_init()
379 # parse $args after "submodule ... init".
380 while test $# -ne 0
382 case "$1" in
383 -q|--quiet)
384 GIT_QUIET=1
387 shift
388 break
391 usage
394 break
396 esac
397 shift
398 done
400 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
404 # Unregister submodules from .git/config and remove their work tree
406 cmd_deinit()
408 # parse $args after "submodule ... deinit".
409 deinit_all=
410 while test $# -ne 0
412 case "$1" in
413 -f|--force)
414 force=$1
416 -q|--quiet)
417 GIT_QUIET=1
419 --all)
420 deinit_all=t
423 shift
424 break
427 usage
430 break
432 esac
433 shift
434 done
436 if test -n "$deinit_all" && test "$#" -ne 0
437 then
438 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
439 usage
441 if test $# = 0 && test -z "$deinit_all"
442 then
443 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
447 git submodule--helper list --prefix "$wt_prefix" "$@" ||
448 echo "#unmatched" $?
450 while read -r mode sha1 stage sm_path
452 die_if_unmatched "$mode" "$sha1"
453 name=$(git submodule--helper name "$sm_path") || exit
455 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
457 # Remove the submodule work tree (unless the user already did it)
458 if test -d "$sm_path"
459 then
460 # Protect submodules containing a .git directory
461 if test -d "$sm_path/.git"
462 then
463 die "$(eval_gettext "\
464 Submodule work tree '\$displaypath' contains a .git directory
465 (use 'rm -rf' if you really want to remove it including all of its history)")"
468 if test -z "$force"
469 then
470 git rm -qn "$sm_path" ||
471 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
473 rm -rf "$sm_path" &&
474 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
475 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
478 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
480 # Remove the .git/config entries (unless the user already did it)
481 if test -n "$(git config --get-regexp submodule."$name\.")"
482 then
483 # Remove the whole section so we have a clean state when
484 # the user later decides to init this submodule again
485 url=$(git config submodule."$name".url)
486 git config --remove-section submodule."$name" 2>/dev/null &&
487 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
489 done
492 is_tip_reachable () (
493 sanitize_submodule_env &&
494 cd "$1" &&
495 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
496 test -z "$rev"
499 fetch_in_submodule () (
500 sanitize_submodule_env &&
501 cd "$1" &&
502 case "$2" in
504 git fetch ;;
506 shift
507 git fetch $(get_default_remote) "$@" ;;
508 esac
512 # Update each submodule path to correct revision, using clone and checkout as needed
514 # $@ = requested paths (default to all)
516 cmd_update()
518 # parse $args after "submodule ... update".
519 while test $# -ne 0
521 case "$1" in
522 -q|--quiet)
523 GIT_QUIET=1
525 --progress)
526 progress="--progress"
528 -i|--init)
529 init=1
531 --remote)
532 remote=1
534 -N|--no-fetch)
535 nofetch=1
537 -f|--force)
538 force=$1
540 -r|--rebase)
541 update="rebase"
543 --reference)
544 case "$2" in '') usage ;; esac
545 reference="--reference=$2"
546 shift
548 --reference=*)
549 reference="$1"
551 -m|--merge)
552 update="merge"
554 --recursive)
555 recursive=1
557 --checkout)
558 update="checkout"
560 --recommend-shallow)
561 recommend_shallow="--recommend-shallow"
563 --no-recommend-shallow)
564 recommend_shallow="--no-recommend-shallow"
566 --depth)
567 case "$2" in '') usage ;; esac
568 depth="--depth=$2"
569 shift
571 --depth=*)
572 depth=$1
574 -j|--jobs)
575 case "$2" in '') usage ;; esac
576 jobs="--jobs=$2"
577 shift
579 --jobs=*)
580 jobs=$1
583 shift
584 break
587 usage
590 break
592 esac
593 shift
594 done
596 if test -n "$init"
597 then
598 cmd_init "--" "$@" || return
602 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
603 ${progress:+"$progress"} \
604 ${wt_prefix:+--prefix "$wt_prefix"} \
605 ${prefix:+--recursive-prefix "$prefix"} \
606 ${update:+--update "$update"} \
607 ${reference:+"$reference"} \
608 ${depth:+--depth "$depth"} \
609 ${recommend_shallow:+"$recommend_shallow"} \
610 ${jobs:+$jobs} \
611 "$@" || echo "#unmatched" $?
612 } | {
613 err=
614 while read -r mode sha1 stage just_cloned sm_path
616 die_if_unmatched "$mode" "$sha1"
618 name=$(git submodule--helper name "$sm_path") || exit
619 if ! test -z "$update"
620 then
621 update_module=$update
622 else
623 update_module=$(git config submodule."$name".update)
624 if test -z "$update_module"
625 then
626 update_module="checkout"
630 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
632 if test $just_cloned -eq 1
633 then
634 subsha1=
635 case "$update_module" in
636 merge | rebase | none)
637 update_module=checkout ;;
638 esac
639 else
640 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
641 git rev-parse --verify HEAD) ||
642 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
645 if test -n "$remote"
646 then
647 branch=$(git submodule--helper remote-branch "$sm_path")
648 if test -z "$nofetch"
649 then
650 # Fetch remote before determining tracking $sha1
651 fetch_in_submodule "$sm_path" $depth ||
652 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
654 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
655 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
656 git rev-parse --verify "${remote_name}/${branch}") ||
657 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
660 if test "$subsha1" != "$sha1" || test -n "$force"
661 then
662 subforce=$force
663 # If we don't already have a -f flag and the submodule has never been checked out
664 if test -z "$subsha1" && test -z "$force"
665 then
666 subforce="-f"
669 if test -z "$nofetch"
670 then
671 # Run fetch only if $sha1 isn't present or it
672 # is not reachable from a ref.
673 is_tip_reachable "$sm_path" "$sha1" ||
674 fetch_in_submodule "$sm_path" $depth ||
675 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
677 # Now we tried the usual fetch, but $sha1 may
678 # not be reachable from any of the refs
679 is_tip_reachable "$sm_path" "$sha1" ||
680 fetch_in_submodule "$sm_path" $depth "$sha1" ||
681 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
684 must_die_on_failure=
685 case "$update_module" in
686 checkout)
687 command="git checkout $subforce -q"
688 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
689 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
691 rebase)
692 command="git rebase"
693 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
694 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
695 must_die_on_failure=yes
697 merge)
698 command="git merge"
699 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
700 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
701 must_die_on_failure=yes
704 command="${update_module#!}"
705 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
706 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
707 must_die_on_failure=yes
710 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
711 esac
713 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
714 then
715 say "$say_msg"
716 elif test -n "$must_die_on_failure"
717 then
718 die_with_status 2 "$die_msg"
719 else
720 err="${err};$die_msg"
721 continue
725 if test -n "$recursive"
726 then
728 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
729 wt_prefix=
730 sanitize_submodule_env
731 cd "$sm_path" &&
732 eval cmd_update
734 res=$?
735 if test $res -gt 0
736 then
737 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
738 if test $res -ne 2
739 then
740 err="${err};$die_msg"
741 continue
742 else
743 die_with_status $res "$die_msg"
747 done
749 if test -n "$err"
750 then
751 OIFS=$IFS
752 IFS=';'
753 for e in $err
755 if test -n "$e"
756 then
757 echo >&2 "$e"
759 done
760 IFS=$OIFS
761 exit 1
767 # Show commit summary for submodules in index or working tree
769 # If '--cached' is given, show summary between index and given commit,
770 # or between working tree and given commit
772 # $@ = [commit (default 'HEAD'),] requested paths (default all)
774 cmd_summary() {
775 summary_limit=-1
776 for_status=
777 diff_cmd=diff-index
779 # parse $args after "submodule ... summary".
780 while test $# -ne 0
782 case "$1" in
783 --cached)
784 cached="$1"
786 --files)
787 files="$1"
789 --for-status)
790 for_status="$1"
792 -n|--summary-limit)
793 summary_limit="$2"
794 isnumber "$summary_limit" || usage
795 shift
797 --summary-limit=*)
798 summary_limit="${1#--summary-limit=}"
799 isnumber "$summary_limit" || usage
802 shift
803 break
806 usage
809 break
811 esac
812 shift
813 done
815 test $summary_limit = 0 && return
817 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
818 then
819 head=$rev
820 test $# = 0 || shift
821 elif test -z "$1" || test "$1" = "HEAD"
822 then
823 # before the first commit: compare with an empty tree
824 head=$(git hash-object -w -t tree --stdin </dev/null)
825 test -z "$1" || shift
826 else
827 head="HEAD"
830 if [ -n "$files" ]
831 then
832 test -n "$cached" &&
833 die "$(gettext "The --cached option cannot be used with the --files option")"
834 diff_cmd=diff-files
835 head=
838 cd_to_toplevel
839 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
840 # Get modified modules cared by user
841 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
842 sane_egrep '^:([0-7]* )?160000' |
843 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
845 # Always show modules deleted or type-changed (blob<->module)
846 if test "$status" = D || test "$status" = T
847 then
848 printf '%s\n' "$sm_path"
849 continue
851 # Respect the ignore setting for --for-status.
852 if test -n "$for_status"
853 then
854 name=$(git submodule--helper name "$sm_path")
855 ignore_config=$(get_submodule_config "$name" ignore none)
856 test $status != A && test $ignore_config = all && continue
858 # Also show added or modified modules which are checked out
859 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
860 printf '%s\n' "$sm_path"
861 done
864 test -z "$modules" && return
866 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
867 sane_egrep '^:([0-7]* )?160000' |
868 cut -c2- |
869 while read -r mod_src mod_dst sha1_src sha1_dst status name
871 if test -z "$cached" &&
872 test $sha1_dst = 0000000000000000000000000000000000000000
873 then
874 case "$mod_dst" in
875 160000)
876 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
878 100644 | 100755 | 120000)
879 sha1_dst=$(git hash-object $name)
881 000000)
882 ;; # removed
884 # unexpected type
885 eval_gettextln "unexpected mode \$mod_dst" >&2
886 continue ;;
887 esac
889 missing_src=
890 missing_dst=
892 test $mod_src = 160000 &&
893 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
894 missing_src=t
896 test $mod_dst = 160000 &&
897 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
898 missing_dst=t
900 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
902 total_commits=
903 case "$missing_src,$missing_dst" in
905 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
908 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
910 t,t)
911 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
914 errmsg=
915 total_commits=$(
916 if test $mod_src = 160000 && test $mod_dst = 160000
917 then
918 range="$sha1_src...$sha1_dst"
919 elif test $mod_src = 160000
920 then
921 range=$sha1_src
922 else
923 range=$sha1_dst
925 GIT_DIR="$name/.git" \
926 git rev-list --first-parent $range -- | wc -l
928 total_commits=" ($(($total_commits + 0)))"
930 esac
932 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
933 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
934 if test $status = T
935 then
936 blob="$(gettext "blob")"
937 submodule="$(gettext "submodule")"
938 if test $mod_dst = 160000
939 then
940 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
941 else
942 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
944 else
945 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
947 if test -n "$errmsg"
948 then
949 # Don't give error msg for modification whose dst is not submodule
950 # i.e. deleted or changed to blob
951 test $mod_dst = 160000 && echo "$errmsg"
952 else
953 if test $mod_src = 160000 && test $mod_dst = 160000
954 then
955 limit=
956 test $summary_limit -gt 0 && limit="-$summary_limit"
957 GIT_DIR="$name/.git" \
958 git log $limit --pretty='format: %m %s' \
959 --first-parent $sha1_src...$sha1_dst
960 elif test $mod_dst = 160000
961 then
962 GIT_DIR="$name/.git" \
963 git log --pretty='format: > %s' -1 $sha1_dst
964 else
965 GIT_DIR="$name/.git" \
966 git log --pretty='format: < %s' -1 $sha1_src
968 echo
970 echo
971 done
974 # List all submodules, prefixed with:
975 # - submodule not initialized
976 # + different revision checked out
978 # If --cached was specified the revision in the index will be printed
979 # instead of the currently checked out revision.
981 # $@ = requested paths (default to all)
983 cmd_status()
985 # parse $args after "submodule ... status".
986 while test $# -ne 0
988 case "$1" in
989 -q|--quiet)
990 GIT_QUIET=1
992 --cached)
993 cached=1
995 --recursive)
996 recursive=1
999 shift
1000 break
1003 usage
1006 break
1008 esac
1009 shift
1010 done
1012 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
1015 # Sync remote urls for submodules
1016 # This makes the value for remote.$remote.url match the value
1017 # specified in .gitmodules.
1019 cmd_sync()
1021 while test $# -ne 0
1023 case "$1" in
1024 -q|--quiet)
1025 GIT_QUIET=1
1026 shift
1028 --recursive)
1029 recursive=1
1030 shift
1033 shift
1034 break
1037 usage
1040 break
1042 esac
1043 done
1044 cd_to_toplevel
1046 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1047 echo "#unmatched" $?
1049 while read -r mode sha1 stage sm_path
1051 die_if_unmatched "$mode" "$sha1"
1053 # skip inactive submodules
1054 if ! git submodule--helper is-active "$sm_path"
1055 then
1056 continue
1059 name=$(git submodule--helper name "$sm_path")
1060 url=$(git config -f .gitmodules --get submodule."$name".url)
1062 # Possibly a url relative to parent
1063 case "$url" in
1064 ./*|../*)
1065 # rewrite foo/bar as ../.. to find path from
1066 # submodule work tree to superproject work tree
1067 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1068 # guarantee a trailing /
1069 up_path=${up_path%/}/ &&
1070 # path from submodule work tree to submodule origin repo
1071 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1072 # path from superproject work tree to submodule origin repo
1073 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1076 sub_origin_url="$url"
1077 super_config_url="$url"
1079 esac
1081 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1082 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1083 git config submodule."$name".url "$super_config_url"
1085 if test -e "$sm_path"/.git
1086 then
1088 sanitize_submodule_env
1089 cd "$sm_path"
1090 remote=$(get_default_remote)
1091 git config remote."$remote".url "$sub_origin_url"
1093 if test -n "$recursive"
1094 then
1095 prefix="$prefix$sm_path/"
1096 eval cmd_sync
1100 done
1103 cmd_absorbgitdirs()
1105 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1108 # This loop parses the command line arguments to find the
1109 # subcommand name to dispatch. Parsing of the subcommand specific
1110 # options are primarily done by the subcommand implementations.
1111 # Subcommand specific options such as --branch and --cached are
1112 # parsed here as well, for backward compatibility.
1114 while test $# != 0 && test -z "$command"
1116 case "$1" in
1117 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1118 command=$1
1120 -q|--quiet)
1121 GIT_QUIET=1
1123 -b|--branch)
1124 case "$2" in
1126 usage
1128 esac
1129 branch="$2"; shift
1131 --cached)
1132 cached="$1"
1135 break
1138 usage
1141 break
1143 esac
1144 shift
1145 done
1147 # No command word defaults to "status"
1148 if test -z "$command"
1149 then
1150 if test $# = 0
1151 then
1152 command=status
1153 else
1154 usage
1158 # "-b branch" is accepted only by "add"
1159 if test -n "$branch" && test "$command" != add
1160 then
1161 usage
1164 # "--cached" is accepted only by "status" and "summary"
1165 if test -n "$cached" && test "$command" != status && test "$command" != summary
1166 then
1167 usage
1170 "cmd_$command" "$@"